
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org Audio Manager Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.Audio.Manager</h1><h2>Description</h2>
<p>The Manager interface is used to manage various audio related aspects. It is  suited to manage the audio routing or can priorize differnt types of audio  streams. For managing different audio device the volume of differnt device  control types can be adjusted.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.Audio.Manager</tt></p>
<h2>Methods</h2><ul>
<li><a href="#SetMode">SetMode</a></li>
<li><a href="#GetMode">GetMode</a></li>
<li><a href="#SetDevice">SetDevice</a></li>
<li><a href="#GetDevice">GetDevice</a></li>
<li><a href="#PushDevice">PushDevice</a></li>
<li><a href="#PullDevice">PullDevice</a></li>
<li><a href="#GetAvailableDevices">GetAvailableDevices</a></li>
<li><a href="#GetVolume">GetVolume</a></li>
<li><a href="#SetVolume">SetVolume</a></li>
<li><a href="#SetMute">SetMute</a></li>
<li><a href="#GetMute">GetMute</a></li>
<li><a href="#RegisterSession">RegisterSession</a></li>
<li><a href="#ReleaseSession">ReleaseSession</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#ModeChanged">ModeChanged</a></li>
<li><a href="#DeviceChanged">DeviceChanged</a></li>
<li><a href="#VolumeChanged">VolumeChanged</a></li>
<li><a href="#MuteChanged">MuteChanged</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><ul>
<li><a href="#NotSupportedDevice">NotSupportedDevice</a></li>
<li><a href="#DeviceStackUnderflow">DeviceStackUnderflow</a></li>
</ul>
<h1>Methods</h1><h3><a name="SetMode">SetMode</a> ( s )</h3>
<p><i>Description:</i> Set the current audio mode. Currently there is only a difference between  normal and call. Normal means all audio use when not in a phone call and call  means all audio within a phone call. </p><h4>Parameters</h4><i>s: mode</i><p>The new audio mode to set. Expected values are:  <ul>  <li>"normal" = Normal audio mode</li>  <li>"call" = Audio mode when a call is active</li>  </ul> </p>
<h3><a name="GetMode">GetMode</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Get the current audio mode which is used. </p><h4>Returns</h4><i>s: mode</i><p>See <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetMode">SetMode</a> for a list of expected values. </p>
<h3><a name="SetDevice">SetDevice</a> ( s )</h3>
<p><i>Description:</i> Set the current audio output device which is used only within the current mode. If  you switch mode then the manager will switch even the output to the last used  one in the new mode. </p><h4>Parameters</h4><i>s: name</i><p>Set the current audio device to use to play audio. Expected values are:  <ul>  <li>"backspeaker" = The speaker on the back side of your device</li>  <li>"frontspeaker" = The speaker on the front side of your device</li>  <li>"headset" = The headset if plugged into the headset jack.</li>  <li>"bluetooth-sco" = Bluetooth SCO audio device</li>  <li>"bluetooth-a2dp" = Bluetooth A2DP audio device</li>  </ul> </p>
<h3><a name="GetDevice">GetDevice</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Get the current audio device. </p><h4>Returns</h4><i>s: device</i><p>The current device used to play audio. For Expected values see  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetDevice">SetDevice</a> </p>
<h3><a name="PushDevice">PushDevice</a> ( s )</h3>
<p><i>Description:</i> Push a new audio device onto the stack and active it. </p><h4>Parameters</h4><i>s: device</i><p>The new active audio device. For a list of expected values see  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetDevice">SetDevice</a> </p>
<h3><a name="PullDevice">PullDevice</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Pull an audio device from the stack and activate the next one. </p><h4>Returns</h4><i>s: device</i><p>The new active audio device. For a list of expected values see  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetDevice">SetDevice</a> </p>
<h3><a name="GetAvailableDevices">GetAvailableDevices</a> ( s ) &rarr; as</h3>
<p><i>Description:</i> Get all available audio outputs for the specified audio mode. </p><h4>Parameters</h4><i>s: mode</i><p>Mode to retrieve the possible devices for. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetMode">SetMode</a> for a list of expected values. </p><h4>Returns</h4><i>as: outputs</i><p>List of available output devices. For a list of expected values see  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetDevice">SetDevice</a> </p>
<h3><a name="GetVolume">GetVolume</a> ( s ) &rarr; i</h3>
<h4>Parameters</h4><i>s: control</i><p>The control you want to get the volume for. </p><h4>Returns</h4><i>i: volume</i><p>The volume in percent (0-100). </p>
<h3><a name="SetVolume">SetVolume</a> ( si )</h3>
<h4>Parameters</h4><i>s: control</i><p>The control you want to set the volume for. Expected values are:  <ul>  <li>"speaker" = The currently active speaker</li>  <li>"micrphone" = The currently active microphone</li>  </ul> </p><i>i: volume</i><p>The volume in percent (0-100). </p>
<h3><a name="SetMute">SetMute</a> ( sb )</h3>
<p><i>Description:</i> Mute current output device. </p><h4>Parameters</h4><i>s: control</i><p>The control you want to set the mute state for. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.html#Manager">Manager</a> for detailed description of the available  controls. </p><i>b: mute</i><p>The mute state of the control. The possible two values are:  <ul>  <li>true: mute the control</li>  <li>false: unmute the control</li>  </ul>  Please note:  <ul>  <li>Muting/unmuting a already muted/unmuted control does not has any effect.</li>  <li>Setting a volume of 0/100 for a control has the same effect as muting/unmuting it.</li>  </ul> </p>
<h3><a name="GetMute">GetMute</a> ( s ) &rarr; b</h3>
<p><i>Description:</i> Mute current output device. </p><h4>Parameters</h4><i>s: control</i><p>The control you want to set the mute state for. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.html#Control">Control</a> for detailed description of the available  controls. </p><h4>Returns</h4><i>b: mute</i><p>The mute state of the control. The possible two values are:  <ul>  <li>true: mute the control</li>  <li>false: unmute the control</li>  </ul> </p>
<h3><a name="RegisterSession">RegisterSession</a> ( s ) &rarr; s</h3>
<p><i>Description:</i> Registering a audio session with the manager. Everytime a application  wants to play audio it has to register a audio session for this so the  audio daemon can control the played audio and maybe mutes the stream if  another audio source is more important than the current one. </p><h4>Parameters</h4><i>s: stream</i><p>The type of the stream the audio is playing on. Expected values are:  <ul>  <li>"media" = Default media playback is happen on this stream.</li>  <li>"alert" = High priority system alerts.</li>  <li>"ringtone" = Responsible for playing ringtones.</li>  <li>"alarm" = Alarm alerts with lower priority than alert.</li>  <li>"navigation" = Audio for navigation purpose.</li>  </ul> </p><h4>Returns</h4><i>s: token</i><p>A four byte long byte sequence to identify the audio session. The  token is needed to release the session after it is over. </p>
<h3><a name="ReleaseSession">ReleaseSession</a> ( s )</h3>
<p><i>Description:</i> Release a audio session from the manager after audio playback is over. </p><h4>Parameters</h4><i>s: token</i><p>A four byte long byte sequence to identify the audio session. The  token is generated and assigned when calling RegisterSession(). </p>
<h1>Signals</h1><h3><h3><a name="ModeChanged">ModeChanged</a> ( s )</h3><h4>Parameters</h4><i>s: mode</i><p>The new audio mode. See <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.html#Mode">Mode</a> for possible values. </p></h3>
<h3><h3><a name="DeviceChanged">DeviceChanged</a> ( s )</h3><h4>Parameters</h4><i>s: device</i><p>The new audio output device. See <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetDevice">SetDevice</a>  for a list of expected values. </p></h3>
<h3><h3><a name="VolumeChanged">VolumeChanged</a> ( si )</h3><h4>Parameters</h4><i>s: control</i><p>The control the volume was changed for. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetVolume">SetVolume</a> for a list of expected values. </p><i>i: volume</i><p>The new volume for the control in percent [0-100]. </p></h3>
<h3><h3><a name="MuteChanged">MuteChanged</a> ( sb )</h3><h4>Parameters</h4><i>s: control</i><p>The control the mute state was changed for. See  <a href="http://docs.freesmartphone.org/org.freesmartphone.Audio.Manager.html#SetVolume">SetVolume</a> for a list of expected values. </p><i>b: mute</i><p>The new mute state for the control. Possible valus are:  <ul>  <li>true: control was muted</li>  <li>false: control was unmuted</li>  </ul> </p></h3>
<h1>Errors</h1><h3><a name="NotSupportedDevice">NotSupportedDevice</a></h3><p><i>Description:</i> Raised, if the device to process is unsupported by the used router. </p>
<h3><a name="DeviceStackUnderflow">DeviceStackUnderflow</a></h3><p><i>Description:</i> Raised, if there is no more device to pull from the stack. </p>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

